<?php

class ControllerUser
{
    private $mdQuestion;
    private $mdChapter;
    private $mdAnswer;
    private $mdPlayer;
    private $mdLobby;
    private $mdAdministrator;

    private $twig;
    private $vues;

    function __construct()
    {
        global $vues, $twig;
        session_start();
        try {

            $this->twig = $twig;
            $this->vues = $vues;

            $this->mdQuestion = new ModelQuestion();
            $this->mdAnswer = new ModelAnswer();
            $this->mdChapter = new ModelChapter();
            $this->mdPlayer = new ModelPlayer();
            $this->mdLobby = new ModelLobby();
            $this->mdAdministrator = new ModelAdministrator();
        } catch (PDOException $e) {
            // $dataVueEreur[] = "Erreur inattendue!!! ";
            // require(__DIR__.'/../vues/erreur.php');
        } catch (Exception $e2) {
            // $dataVueEreur[] = "Erreur inattendue!!! ";
            // require ($rep.$vues['erreur']);
        }
    }

    function home()
    {
        echo $this->twig->render($this->vues["home"]);
    }
    function themeChoice()
    {
        $chapters = $this->mdChapter->getChapters();
        echo $this->twig->render($this->vues["themeChoice"], [
            'chapters' => $chapters,
        ]);
    }
    function singleplayer()
    {
        echo $this->twig->render($this->vues["singleplayer"]);
    }

    function multiplayer()
    {
        echo $this->twig->render($this->vues["multiplayer"]);
    }

    function login()
    {
        echo $this->twig->render($this->vues["loginAdmin"], [
            'error' => $_SESSION["error"],
        ]);

        $_SESSION["error"] = "";
    }

    function verifyAdmin()
    {
        $username = $_POST['username'];
        $password = $_POST['password'];

        $Administrator = [
            'username' => $username,
            'password' => $password,
        ];

        $AdministratorIsOk = $this->mdAdministrator->verifyAdministrator($Administrator);
        if ($AdministratorIsOk != null) {
            $_SESSION["idAdminConnected"] = $AdministratorIsOk;
            header("Location:/admin/administrators");
        } else {
            $_SESSION["error"] = "utilisateur introuvable.";
            header("Location:/login");
        }
    }

    function verifySingleplayer()
    {
        $_SESSION["Score"]=0;
        $_SESSION["PrevTime"]= new DateTime('now');
        $difficulty = $_POST['difficulty'];
        $chapter = $_POST['chapter'];
        $difficultyIsOk = TRUE;
        $chapterIsOk = TRUE;

        if (!($difficulty == 0 or $difficulty == 1 or $difficulty == 2)) {
            $_SESSION["error"] = "Valeur de difficulté invalide";
            $difficultyIsOk = FALSE;
        }

        if ($this->mdChapter->verifyChapter($chapter) == NULL) {
            $_SESSION["error"] = "Valeur de chapitre invalide";
            $chapterIsOk = FALSE;
        }
        if ($difficultyIsOk and $chapterIsOk) {
            $_SESSION["Questions"] = $this->mdQuestion->getQuestionsByChapterAndDifficulty($chapter, $difficulty);
            foreach ($_SESSION["Questions"] as &$question) {
                $answers = $this->mdAnswer->getAnswersByIDQuestions($question['id']);
                $question['answers'] = $answers;
            }
            echo $this->twig->render($this->vues["singleplayer"], [
                'questions' => $_SESSION["Questions"],
                'numQuestion' => 0,
            ]);
        } else {
            $_SESSION["error"] = "Valeur de choix de thème invalide";
            header("Location:/themeChoice");
        }
    }

    function verifQuestion()
    //Only Handdle solo game
    {
        $_SESSION["CurrTime"]= new DateTime('now');
        $answerNumber = $_POST["answer"];
        $numQuestion = $_POST["numQuestion"] + 1;
        if (!($answerNumber == 0 or $answerNumber == 1 or $answerNumber == 2 or $answerNumber == 3)) {
            $_SESSION["error"] = "Valeur de choix de réponse invalide";
            echo $this->twig->render($this->vues["singleplayer"], [
                'questions' => $_SESSION["Questions"],
                'numQuestion' => $numQuestion-1,
            ]);
        } else {
            if ($numQuestion > 9) {
                var_dump($_SESSION["Score"]);
                /// echo $this->twig->render($this->vues["ViewScore"], [
                ///    'score' => $_SESSION["Score"],    
                /// ];
            } else {
                var_dump($_SESSION["Questions"][$numQuestion - 1]['idanswergood']);
                var_dump($_SESSION["Questions"][$numQuestion - 1]['answers'][$answerNumber]['id']);
                if ($_SESSION["Questions"][$numQuestion - 1]['idanswergood'] == $_SESSION["Questions"][$numQuestion - 1]['answers'][$answerNumber]['id']) {
                    $time = $_SESSION["PrevTime"]->diff($_SESSION["CurrTime"]);
                    $_SESSION["Score"]= $_SESSION["Score"] + 80 + 40*((30-$time->s)/100*10/3);
                }
                $_SESSION["PrevTime"] = $_SESSION["CurrTime"];
                echo $this->twig->render($this->vues["singleplayer"], [
                    'questions' => $_SESSION["Questions"],
                    'numQuestion' => $numQuestion,
                ]);
            }
        }
    }
    function passer()
    {
        $numQuestion = $_POST["numQuestion"] + 1;
        if ($numQuestion > 9) {
            echo $this->twig->render($this->vues["home"]);
            //EN GROS IL FAUT AFFICHER LE SCORE (C'est copilot qui a fait ça, la fin du commentaire j'veux dire)
            //Si faut paser un param score de page en page dittes le moi je le ferais dw
        } else {
            $_SESSION["PrevTime"] = $_SESSION["CurrTime"];  
            echo $this->twig->render($this->vues["singleplayer"], [
                'questions' => $_SESSION["Questions"],
                'numQuestion' => $numQuestion,
            ]);
        }
    }
}
